/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Affinity.xs. Do not edit this file, edit Affinity.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Affinity.xs"
// PERL_NO_GET_CONTEXT is not used here, so it's OK to define it after inculding these files
#include "EXTERN.h"
#include "perl.h"

// There are a lot of macro about threads: USE_ITHREADS, USE_5005THREADS, I_PTHREAD, I_MACH_CTHREADS, OLD_PTHREADS_API
// This symbol, if defined, indicates that Perl should be built to use the interpreter-based threading implementation.
#ifndef USE_ITHREADS
#   define PERL_NO_GET_CONTEXT
#endif

#include "XSUB.h"

#ifdef I_PTHREAD
#   include "pthread.h"
#endif

#ifdef I_MACH_CTHREADS
#   include "mach/cthreads.h"
#endif


#include <sched.h>
#include <errno.h>
#include <sys/sysinfo.h>
//#include <unistd.h>

struct xs_state {
    int max_cpus;
    cpu_set_t *set;
    size_t size;
    char *class_name;
};

typedef struct xs_state Linux_Sys_CPU_Affinity;

static inline int get_available_nprocs (void) {

    static int available_cpus_cnt = 0;

    /* get available amount of CPU cores */
    if (available_cpus_cnt == 0)
        available_cpus_cnt = get_nprocs(); // sysconf(_SC_NPROCESSORS_ONLN);

    /* if we're failed, then use constant, mostly it equals to 1024 */
    if (available_cpus_cnt == -1)
        available_cpus_cnt = CPU_SETSIZE;

    return available_cpus_cnt;
}

inline void init_set (Linux_Sys_CPU_Affinity *cpuset, AV *av) {

    if (cpuset->set != NULL)
        CPU_FREE(cpuset->set);

    cpuset->size = CPU_ALLOC_SIZE(cpuset->max_cpus);
    cpuset->set = CPU_ALLOC(cpuset->max_cpus);

    if (cpuset->set == NULL) {
        SV *msg = sv_2mortal( newSVpvf("Failed to allocate memory for %i CPUs", cpuset->max_cpus) );
        croak((char *) SvPV_nolen(msg));
    }

    CPU_ZERO_S(cpuset->size, cpuset->set);

    if (av != NULL) {
        SSize_t i;
        SSize_t av_len = av_len(av) + 1;
        for (i = 0; i < av_len; i++) {
            size_t cpu = SvIV((SV*)*av_fetch(av, i, 0)); // SvIVX to coerce value into IV
            //Perl_warner_nocontext(aTHX_ packWARN(WARN_QW), "value = %i\n", cpu);
            CPU_SET_S(cpu, cpuset->size, cpuset->set);
        }
    }
}

inline AV* _extract_and_validate_av(SV *sv) {

    if (!SvOK(sv))
        croak("the CPU's list can't be undefined");

    if (SvTIED_mg(sv, PERL_MAGIC_tied))
        croak("tied objects aren't supported");

    if (!SvROK(sv))
        croak("the CPU's list must be an array reference");

    SV *ref = SvRV(sv);
    AV *av;

    switch (SvTYPE(ref)) {
        case SVt_PVAV: // $ref eq "ARRAY"
            av = (AV *) ref;
            break;
        default:       // $ref ne "ARRAY"
            croak("the CPU's list must be an array reference");
    }

    SSize_t i;
    SSize_t bad_arg = -1;
    // SV **arr = AvARRAY(av);

    for (i = av_len(av); i >= 0; i--) {
        SV *val = (SV *) *av_fetch(av, i, 0);
        // SV *val = arr[i];
        if (!SvOK(val) || !SvIOK(val)) {
            bad_arg = i;
            break;
        }
    }

    if (bad_arg != -1) {
        croak("Not an integer at position %i", bad_arg);
    }

    return av;
}

inline Linux_Sys_CPU_Affinity* make_from_object(Linux_Sys_CPU_Affinity *cpuset, int copy_set) {

    Linux_Sys_CPU_Affinity *new_cpuset = (Linux_Sys_CPU_Affinity *) safemalloc(sizeof(Linux_Sys_CPU_Affinity));
    uint32_t cpu;

    new_cpuset->max_cpus = cpuset->max_cpus;
    new_cpuset->class_name = cpuset->class_name;

    init_set(new_cpuset, NULL);

    if (copy_set != 0)
        for (cpu = 0; cpu < new_cpuset->max_cpus; cpu++) {
            int res = CPU_ISSET_S(cpu, cpuset->size, cpuset->set);
            if (res != 0)
                CPU_SET_S(cpu, new_cpuset->size, new_cpuset->set);
        }

    return new_cpuset;
}

inline AV* get_cpus_from_cpuset(Linux_Sys_CPU_Affinity *cpuset) {
    AV* av = newAV();    
    uint32_t cpu;
    for (cpu = 0; cpu < cpuset->max_cpus; cpu++) {
        int res = CPU_ISSET_S(cpu, cpuset->size, cpuset->set);
        if (res != 0)
            av_push(av, newSVuv(cpu));
    }
    sv_2mortal((SV*) av);
    return av;
}

SV* get_sched_error_text(int error_code, int is_get_affinity) {
    SV *error = sv_2mortal(newSV(0));
    switch (error_code) {
        case EFAULT:
            sv_setpv(error, "A supplied memory address was invalid");
            break;
        case EINVAL:
            if (is_get_affinity)
                sv_setpv(error, "The cpusetsize is smaller than the size of the affinity mask used by the kernel");
            else
                sv_setpv(error, "The affinity bit mask mask contains no processors that are currently physically on the system and permitted to the thread");
            break;
        case EPERM:
            sv_setpv(error, "The calling thread does not have appropriate privileges");
            break;
        case ESRCH:
            sv_setpv(error, "The thread whose ID is pid could not be found");
            break;
        default:
            sv_setpv(error, "Unknown error has occurred");
    }
    return error;
}


#line 186 "Affinity.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 330 "Affinity.c"

XS_EUPXS(XS_Linux__Sys__CPU__Affinity_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class_name, sv = &PL_sv_undef");
    {
	char *	class_name = (char *)SvPV_nolen(ST(0))
;
	SV *	sv;
#line 184 "Affinity.xs"
    Linux_Sys_CPU_Affinity *cpuset;
    AV* av = NULL;
#line 345 "Affinity.c"
	Linux_Sys_CPU_Affinity *	RETVAL;

	if (items < 2)
	    sv = &PL_sv_undef;
	else {
	    sv = ST(1)
;
	}
#line 188 "Affinity.xs"
    if (SvOK(sv))
        av = _extract_and_validate_av(sv);

    cpuset = (Linux_Sys_CPU_Affinity *) safemalloc(sizeof(Linux_Sys_CPU_Affinity));

    cpuset->set = NULL;
    cpuset->max_cpus = get_available_nprocs();
    cpuset->class_name = class_name;

    init_set(cpuset, av);

    // ENTER; SAVETMPS; // {
    // code
    // FREETMPS; LEAVE; // }

    RETVAL = cpuset;
#line 371 "Affinity.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, class_name, (void*) RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cpuset");
    {
	Linux_Sys_CPU_Affinity *	cpuset;
	Linux_Sys_CPU_Affinity *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpuset = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpuset is not of type CPU::Affinity")
;
#line 211 "Affinity.xs"
    char* class_name = cpuset->class_name;
    RETVAL = make_from_object(cpuset, 1);
#line 407 "Affinity.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, class_name, (void*) RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_and); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_and)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cpusetA, cpusetB");
    {
	Linux_Sys_CPU_Affinity *	cpusetA;
	Linux_Sys_CPU_Affinity *	cpusetB;
	Linux_Sys_CPU_Affinity *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpusetA = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpusetA is not of type CPU::Affinity")
;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(1), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(1)));
            cpusetB = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpusetB is not of type CPU::Affinity")
;
#line 221 "Affinity.xs"
    char* class_name = cpusetA->class_name;

    if (cpusetA->size != cpusetB->size)
        croak("The size of given cpusets are different");

    Linux_Sys_CPU_Affinity *new_cpuset = make_from_object(cpusetA, 1);

    CPU_AND_S(cpusetA->size, new_cpuset->set, cpusetA->set, cpusetB->set);
    RETVAL = new_cpuset;
#line 463 "Affinity.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, class_name, (void*) RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_or); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_or)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cpusetA, cpusetB");
    {
	Linux_Sys_CPU_Affinity *	cpusetA;
	Linux_Sys_CPU_Affinity *	cpusetB;
	Linux_Sys_CPU_Affinity *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpusetA = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpusetA is not of type CPU::Affinity")
;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(1), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(1)));
            cpusetB = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpusetB is not of type CPU::Affinity")
;
#line 238 "Affinity.xs"
    char* class_name = cpusetA->class_name;

    if (cpusetA->size != cpusetB->size)
        croak("The size of given cpusets are different");

    Linux_Sys_CPU_Affinity *new_cpuset = make_from_object(cpusetA, 1);

    CPU_OR_S(cpusetA->size, new_cpuset->set, cpusetA->set, cpusetB->set);
    RETVAL = new_cpuset;
#line 519 "Affinity.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, class_name, (void*) RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_xor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_xor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cpusetA, cpusetB");
    {
	Linux_Sys_CPU_Affinity *	cpusetA;
	Linux_Sys_CPU_Affinity *	cpusetB;
	Linux_Sys_CPU_Affinity *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpusetA = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpusetA is not of type CPU::Affinity")
;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(1), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(1)));
            cpusetB = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpusetB is not of type CPU::Affinity")
;
#line 255 "Affinity.xs"
    char* class_name = cpusetA->class_name;

    if (cpusetA->size != cpusetB->size)
        croak("The size of given cpusets are different");

    Linux_Sys_CPU_Affinity *new_cpuset = make_from_object(cpusetA, 1);

    CPU_XOR_S(cpusetA->size, new_cpuset->set, cpusetA->set, cpusetB->set);
    RETVAL = new_cpuset;
#line 575 "Affinity.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, class_name, (void*) RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_zero); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_zero)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cpuset");
    {
	Linux_Sys_CPU_Affinity *	cpuset;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpuset = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpuset is not of type CPU::Affinity")
;
#line 271 "Affinity.xs"
    init_set(cpuset, NULL);
    XSRETURN_EMPTY;
#line 610 "Affinity.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_reset)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "cpuset, sv = &PL_sv_undef");
    {
	Linux_Sys_CPU_Affinity *	cpuset;
	SV *	sv;
#line 279 "Affinity.xs"
    AV* av = NULL;
#line 627 "Affinity.c"

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpuset = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpuset is not of type CPU::Affinity")
;

	if (items < 2)
	    sv = &PL_sv_undef;
	else {
	    sv = ST(1)
;
	}
#line 281 "Affinity.xs"
    if (SvOK(sv))
        av = _extract_and_validate_av(sv);
    init_set(cpuset, av);
    XSRETURN_EMPTY;
#line 652 "Affinity.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_isset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_isset)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cpuset, cpu");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Linux_Sys_CPU_Affinity *	cpuset;
	UV	cpu = (UV)SvUV(ST(1))
;
	IV	RETVAL;
	dXSTARG;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpuset = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpuset is not of type CPU::Affinity")
;
#line 291 "Affinity.xs"
    int res = CPU_ISSET_S((uint32_t) cpu, cpuset->size, cpuset->set);
    mXPUSHu( res );
    XSRETURN(1);
#line 688 "Affinity.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_set)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cpuset, cpu");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Linux_Sys_CPU_Affinity *	cpuset;
	UV	cpu = (UV)SvUV(ST(1))
;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpuset = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpuset is not of type CPU::Affinity")
;
#line 300 "Affinity.xs"
    CPU_SET_S((uint32_t) cpu, cpuset->size, cpuset->set);
    XSRETURN_EMPTY;
#line 722 "Affinity.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_clr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_clr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cpuset, cpu");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Linux_Sys_CPU_Affinity *	cpuset;
	UV	cpu = (UV)SvUV(ST(1))
;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpuset = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpuset is not of type CPU::Affinity")
;
#line 308 "Affinity.xs"
    CPU_CLR_S((uint32_t) cpu, cpuset->size, cpuset->set);
    XSRETURN_EMPTY;
#line 756 "Affinity.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cpuset");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Linux_Sys_CPU_Affinity *	cpuset;
	UV	RETVAL;
	dXSTARG;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpuset = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpuset is not of type CPU::Affinity")
;
#line 315 "Affinity.xs"
    int cpu_count = CPU_COUNT_S(cpuset->size, cpuset->set);
    mXPUSHu( cpu_count ); // PUSHs(sv_2mortal(newSVuv(cpu_count)));
    XSRETURN(1);
#line 791 "Affinity.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_equal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_cpu_equal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cpusetA, cpusetB");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Linux_Sys_CPU_Affinity *	cpusetA;
	Linux_Sys_CPU_Affinity *	cpusetB;
	IV	RETVAL;
	dXSTARG;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpusetA = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpusetA is not of type CPU::Affinity")
;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(1), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(1)));
            cpusetB = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpusetB is not of type CPU::Affinity")
;
#line 324 "Affinity.xs"
    int res = 0;
    if (cpusetA->size == cpusetB->size)
        res = CPU_EQUAL_S(cpusetA->size, cpusetA->set, cpusetB->set);
    mXPUSHu( res );
    XSRETURN(1);
#line 841 "Affinity.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_get_cpus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_get_cpus)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cpuset");
    {
	Linux_Sys_CPU_Affinity *	cpuset;
	AV *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpuset = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpuset is not of type CPU::Affinity")
;
#line 334 "Affinity.xs"
    RETVAL = get_cpus_from_cpuset(cpuset);
#line 871 "Affinity.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_get_affinity); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_get_affinity)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cpuset, pid");
    {
	Linux_Sys_CPU_Affinity *	cpuset;
	UV	pid = (UV)SvUV(ST(1))
;
	AV *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpuset = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpuset is not of type CPU::Affinity")
;
#line 343 "Affinity.xs"
    Linux_Sys_CPU_Affinity *new_cpuset = make_from_object(cpuset, 0);
    int res = sched_getaffinity((pid_t) pid, new_cpuset->size, new_cpuset->set);
    if (res == -1) {
        SV *error = get_sched_error_text(errno, 1);
        croak((char *) SvPV_nolen(error));
    }
    RETVAL = get_cpus_from_cpuset(new_cpuset);
    safefree(new_cpuset);
#line 915 "Affinity.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_set_affinity); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_set_affinity)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cpuset, pid");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Linux_Sys_CPU_Affinity *	cpuset;
	UV	pid = (UV)SvUV(ST(1))
;
	IV	RETVAL;
	dXSTARG;

        /*
          We disable the derived check because it's kinda useless but slow.
        */
        if (1 || sv_derived_from(ST(0), "CPU::Affinity"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            cpuset = INT2PTR(Linux_Sys_CPU_Affinity *, tmp);
          }
        else
          croak("cpuset is not of type CPU::Affinity")
;
#line 359 "Affinity.xs"
    int res = sched_setaffinity((pid_t) pid, cpuset->size, cpuset->set);
    if (res == -1) {
        SV *error = get_sched_error_text(errno, 0);
        croak((char *) SvPV_nolen(error));
    }
    mXPUSHi( res );
    XSRETURN(1);
#line 961 "Affinity.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cpuset");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 370 "Affinity.xs"
    Linux_Sys_CPU_Affinity *self = (Linux_Sys_CPU_Affinity *) SvUV(SvRV(ST(0)));
    if (PL_dirty)
        return;
    CPU_FREE(self->set);
    safefree(self);
    XSRETURN_EMPTY;
#line 984 "Affinity.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__Sys__CPU__Affinity_get_nprocs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Sys__CPU__Affinity_get_nprocs)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	IV	RETVAL;
	dXSTARG;
#line 380 "Affinity.xs"
    int nprocs = get_available_nprocs();
    mXPUSHi( nprocs );
    XSRETURN(1);
#line 1006 "Affinity.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Linux__Sys__CPU__Affinity); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Linux__Sys__CPU__Affinity)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Linux::Sys::CPU::Affinity::new", XS_Linux__Sys__CPU__Affinity_new);
        newXS_deffile("Linux::Sys::CPU::Affinity::clone", XS_Linux__Sys__CPU__Affinity_clone);
        newXS_deffile("Linux::Sys::CPU::Affinity::cpu_and", XS_Linux__Sys__CPU__Affinity_cpu_and);
        newXS_deffile("Linux::Sys::CPU::Affinity::cpu_or", XS_Linux__Sys__CPU__Affinity_cpu_or);
        newXS_deffile("Linux::Sys::CPU::Affinity::cpu_xor", XS_Linux__Sys__CPU__Affinity_cpu_xor);
        newXS_deffile("Linux::Sys::CPU::Affinity::cpu_zero", XS_Linux__Sys__CPU__Affinity_cpu_zero);
        newXS_deffile("Linux::Sys::CPU::Affinity::reset", XS_Linux__Sys__CPU__Affinity_reset);
        newXS_deffile("Linux::Sys::CPU::Affinity::cpu_isset", XS_Linux__Sys__CPU__Affinity_cpu_isset);
        newXS_deffile("Linux::Sys::CPU::Affinity::cpu_set", XS_Linux__Sys__CPU__Affinity_cpu_set);
        newXS_deffile("Linux::Sys::CPU::Affinity::cpu_clr", XS_Linux__Sys__CPU__Affinity_cpu_clr);
        newXS_deffile("Linux::Sys::CPU::Affinity::cpu_count", XS_Linux__Sys__CPU__Affinity_cpu_count);
        newXS_deffile("Linux::Sys::CPU::Affinity::cpu_equal", XS_Linux__Sys__CPU__Affinity_cpu_equal);
        newXS_deffile("Linux::Sys::CPU::Affinity::get_cpus", XS_Linux__Sys__CPU__Affinity_get_cpus);
        newXS_deffile("Linux::Sys::CPU::Affinity::get_affinity", XS_Linux__Sys__CPU__Affinity_get_affinity);
        newXS_deffile("Linux::Sys::CPU::Affinity::set_affinity", XS_Linux__Sys__CPU__Affinity_set_affinity);
        newXS_deffile("Linux::Sys::CPU::Affinity::DESTROY", XS_Linux__Sys__CPU__Affinity_DESTROY);
        newXS_deffile("Linux::Sys::CPU::Affinity::get_nprocs", XS_Linux__Sys__CPU__Affinity_get_nprocs);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
